<template>
  <app-options
    title="List Options"
    :sections="sections"
    :open="open"
    @close="handleCancel"
  >
    <template v-slot:primary>
      <app-options-item
        :id="id"
        @onClick="handleCreate"
        name="Create Card"
        icon="plus"
        color="secondary"
      />
    </template>
    <template v-slot:navigation>
      <app-options-item
        :id="id"
        @onClick="moveLeft"
        name="Move Left"
        icon="chevron-left"
        color="primary"
      />
      <app-options-item
        :id="id"
        @onClick="moveRight"
        name="Move Right"
        icon="chevron-right"
        color="primary"
      />
    </template>
    <template v-slot:secondary>
      <app-options-item
        :id="id"
        @onClick="handleDelete"
        name="Delete List"
        icon="trash"
        color="danger"
      />
    </template>
  </app-options>
</template>

<script lang="ts">
import { v4 as uuidV4 } from "uuid";
import { Card } from "@/core/database";
import { defineComponent } from "vue";
import AppOptions from "./Options.vue";
import AppOptionsItem from "./OptionsItem.vue";

type sectionOptions = "primary" | "secondary" | "navigation";

export default defineComponent({
  components: { AppOptions, AppOptionsItem },
  emits: ["create", "delete", "cancel", "move-left", "move-right"],
  props: {
    open: {
      type: Boolean,
      required: true,
    },
    id: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      sections: ["primary", "navigation", "secondary"] as sectionOptions[],
    };
  },
  methods: {
    handleCreate() {
      const newCard = new Card(uuidV4(), "New Card", this.id, "", new Date());
      this.$emit("create", newCard);
      this.handleCancel();
    },
    handleDelete() {
      this.$emit("delete");
      this.handleCancel();
    },
    handleCancel() {
      this.$emit("cancel");
    },
    moveLeft() {
      this.$emit("move-left");
      this.handleCancel();
    },
    moveRight() {
      this.$emit("move-right");
      this.handleCancel();
    },
  },
});
</script>
